function cons(text)
	print("[" .. round(love.timer.getTime()-begint, 2) .. "\\" .. round(love.timer.getTime()-begint-sincet, 2) .. "] " .. text)
	sincet = round(love.timer.getTime()-begint, 2)
end

function round(num, idp)
  local mult = 10^(idp or 0)
  return math.floor(num * mult + 0.5) / mult
end

function anythingbutnil(this)
	if this == nil then
		return ""
	else
		return this
	end
end

function anythingbutnil0(this)
	-- Same, but instead of an empty string return 0
	if this == nil then
		return 0
	else
		return this
	end
end

function fatalerror(msg)
	errormsg = msg
	cons("FATAL ERROR: " .. msg)
	state = -1
end

function backspace(text)
	--[[ UTF-8 library is 0.9.2+
	-- get the byte offset to the last UTF-8 character in the string.
	local byteoffset = utf8.offset(text, -1)

	if byteoffset then
		-- remove the last UTF-8 character.
		-- string.sub operates on bytes rather than UTF-8 characters, so we couldn't do string.sub(text, 1, -2).
		text = string.sub(text, 1, byteoffset - 1)
	end
	]]

	worktext = text
	while true do
		lastchar = string.sub(worktext, -1, -1) -- als dit niet werkt...
		if lastchar == "" then return "" end

		-- Are we about to kill a UTF-8 continuation byte?
		if string.sub(toBinary(lastchar), 1, 2) == "10" then
			-- We are, do this again.
			worktext = string.sub(worktext, 1, -2)
		else
			-- All clear!
			return string.sub(worktext, 1, -2)
		end
	end
end

-- numberString toBinary http://pastebin.com/LkFYQPGP
function numberString(number)
	local s = ""
	repeat
		local remainder = number % 2
		s = remainder..s
		number = (number-remainder)/2
	until number==0
	return s
end

function chartobinary(char)
	string.format("%08d",numberString(string.byte(char)))
	-- Geen wonder dat dit nil geeft!!
end

function toBinary(str)
	if #str > 0 then
		local result = ""
		for a = 1, #str do
			result = result..string.format("%08d",numberString(string.byte(string.sub(str,a,a))))
		end
		return result
	else return nil
	end
end

-- https://love2d.org/wiki/String_exploding
function explode(div, str)
	--cons("Explode is being used on string " .. str)
	assert(type(str) == "string" and type(div) == "string", "invalid arguments for string explosion (div is " .. type(div) .. " [" .. anythingbutnil(div) .. "], str is " .. type(str) .. " [" .. anythingbutnil(str) .. "])")
	local o = {}
	while true do
		local pos1,pos2 = str:find(div)
		if not pos1 then
			o[#o+1] = str
			break
		end
		o[#o+1],str = str:sub(1,pos1-1),str:sub(pos2+1)
	end
	return o
end

function implode(div, tbl)
	return table.concat(tbl, div)
end

function startinput()
	cons("Input started (not once)")
	input = ""
	takinginput = true
	currentmultiinput = 0
end

function startinputonce()
	if not takinginput then
		cons("Input started (once)")
		input = ""
		takinginput = true
		currentmultiinput = 0
	end
end

function stopinput()
	cons("Input stopped.")
	-- Do not clear input here, because then we can't use it anymore after using stopinput(). Output will now be locked.
	takinginput = false
	currentmultiinput = 0
end

function startmultiinput(usethese)
	cons("Multi-input started: " .. #usethese)
	multiinput = usethese
	takinginput = false
	currentmultiinput = 0
end

function tostate(new, dontinitialize)
	if dontinitialize == nil then
		dontinitialize = false
	end
	
	oldstate = state
	state = anythingbutnil0(tonumber(new)) -- please
	if not dontinitialize then
		cons("State changed: " .. oldstate .. " => " .. state .. " (inited)")
		loadstate(state) -- just so states can be prepared easily
	else
		cons("State changed: " .. oldstate .. " => " .. state .. " (not initialized)")
	end
end

function loadstate(new)
	if new == 1 then
	
		-- DON'T FORGET editingmap
		-- ^ has been forgotten, has been realized, has been fixed.
	
		--roomdata = {}; roomdata[0] = {} -- temporary
		--roomdata[0][0], entitydata, metadata = loademptyroom()
		--success, metadata, roomdata, entitydata, levelmetadata, scripts = loadlevel("tilesets2.vvvvvv")
		tilespicker = false
		selectedtool = 1; selectedsubtool = {1,1,1,1,1, 1,1,1,1,1, 1,1,1,1,1, 1,1}
		selectedtile = 1
		selectedtileset = 0 --"spacestation" --"outside"
		selectedcolor = 0 --"c9" --"red"
		lefttoolscroll = 16 -- offset
		leftsubtoolscroll = 16
		zoomscale = 1 -- Or 1/2 or 1/4 or w/e
		dropdown = 0
		roomx = 0
		roomy = 0
		
		if levelmetadata ~= nil then
			selectedtileset = levelmetadata[(roomy)*20 + (roomx+1)].tileset
			selectedcolor = levelmetadata[(roomy)*20 + (roomx+1)].tilecol
		end
		
		editingroomtext = 0
		editingroomname = false
		roomoptpage2 = false
		warpid = nil
		
		minsmear = -1; maxsmear = -1
		
		if not success then
			fatalerror("Unable to open file: " .. metadata)
		end
		
		-- Terminal -> open would crash otherwise
		scriptlistscroll = 0
	elseif new == 3 then
		-- scriptname == ""
		-- scriptlines = {}
		editingline = 1 --#scriptlines
		textlinestogo = 0
		startinput()
		scriptscroll = 0
		input = scriptlines[editingline]
		syntaxhlon = true
		textsize = false
	elseif new == 4 then
		success, metadata, contents, entities, levelmetadata, scripts = loadlevel("testlevel.vvvvvv")
	elseif new == 5 then
		userprofile = os.getenv('USERPROFILE')
		lerror, levelsfolder = getlevelsfolder()
		files = listdirs(userprofile)
	elseif new == 6 then
		userprofile = os.getenv('USERPROFILE')
		lerror, levelsfolder = getlevelsfolder()
		if lerror == 0 then
			files = listfiles(levelsfolder)
		end
		loadtileset("tiles.png")
		loadtileset("tiles2.png")
		loadsprites("sprites.png", 32)
	elseif new == 9 then
		youdidanswer = ""
		dialog.new("Not much to see here. Other than that I got this working.\n\nAhem.\n\n\"Are you absolutely sure you want to delete everything?\"", "", 1, 3, 1)
	elseif new == 10 then
		scriptlistscroll = 0
	elseif new == 11 then
		startinput()
		searchscripts = {}; searchrooms = {}; searchroomtext = {}
		searchedfor = "moot"
		showresults = 100
	elseif new == 12 then
		mapscale = math.min(1/metadata.mapwidth, 1/metadata.mapheight)
		--mapxoffset = (640-(((1/mapscale)-metadata.mapwidth)*mapscale*640))/2
		--mapyoffset = (480-(((1/mapscale)-metadata.mapheight)*mapscale*480))/2
		mapxoffset = (((1/mapscale)-metadata.mapwidth)*mapscale*640)/2
		mapyoffset = (((1/mapscale)-metadata.mapheight)*mapscale*480)/2
		
		selectingrooms = 0
		selected1x = -1; selected1y = -1
		selected2x = -1; selected2y = -1
	elseif new == 15 then
		helplistscroll = 0
		helparticle = 1
		helparticlescroll = 0
	end
	
	if mapscreenshot ~= nil then
		mapscreenshot = nil

		-- Good time to garbage collect the old map away?
		collectgarbage("collect")
	end
end



-------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------- Just as a filler because I need this part often ---------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------------------



function loadtileset(file)
	tilesets[file] = {}
	
	-- Try loading custom assets first
	readsuccess, contents = readimage(levelsfolder, file)
	
	if readsuccess == true then
		-- Custom image!
		cons("Custom image: " .. file)
		--love.filesystem.write("temp/" .. file, contents)
		--tilesets[file]["img"] = love.graphics.newImage("temp/" .. file)
		tilesets[file]["img"] = love.graphics.newImage(love.image.newImageData(love.filesystem.newFileData(contents, file, "file")))
	else
		cons("No custom image for " .. file .. ", " .. contents)
		tilesets[file]["img"] = love.graphics.newImage(file)
	end
	tilesets[file]["width"] = tilesets[file]["img"]:getWidth()
	tilesets[file]["height"] = tilesets[file]["img"]:getHeight()
	tilesets[file]["tileswidth"] = tilesets[file]["width"]/8  -- 16
	tilesets[file]["tilesheight"] = tilesets[file]["height"]/8  -- 16
	
	cons("Loading tileset: " .. file .. ", " .. tilesets[file]["width"] .. "x" .. tilesets[file]["height"] .. ", " .. tilesets[file]["tileswidth"] .. "x" .. tilesets[file]["tilesheight"])
	
	tilesets[file]["tiles"] = {}
	
	for tsy = 0, (tilesets[file]["tilesheight"]-1) do
		for tsx = 0, (tilesets[file]["tileswidth"]-1) do
			tilesets[file]["tiles"][(tsy*tilesets[file]["tileswidth"])+tsx] = love.graphics.newQuad(tsx*8, tsy*8, 8, 8, tilesets[file]["width"], tilesets[file]["height"]) -- 16 16 16 16
		end
	end
end

function loadsprites(file, res)
	tilesets[file] = {}
	
	-- Try loading custom assets first
	readsuccess, contents = readimage(levelsfolder, file)
	
	if readsuccess == true then
		-- Custom image!
		cons("Custom image: " .. file)
		--love.filesystem.write("temp/" .. file, contents)
		--tilesets[file]["img"] = love.graphics.newImage("temp/" .. file)
		tilesets[file]["img"] = love.graphics.newImage(love.image.newImageData(love.filesystem.newFileData(contents, file, "file")))
	else
		cons("No custom image for " .. file .. ", " .. contents)
		tilesets[file]["img"] = love.graphics.newImage(file)
	end
	tilesets[file]["width"] = tilesets[file]["img"]:getWidth()
	tilesets[file]["height"] = tilesets[file]["img"]:getHeight()
	tilesets[file]["tileswidth"] = tilesets[file]["width"]/res -- 32
	tilesets[file]["tilesheight"] = tilesets[file]["height"]/res -- 32
	
	cons("Loading spriteset: " .. file .. ", " .. tilesets[file]["width"] .. "x" .. tilesets[file]["height"] .. ", " .. tilesets[file]["tileswidth"] .. "x" .. tilesets[file]["tilesheight"])
	
	-- Now make everything white so we can color-correct it!
	asimgdata = tilesets[file]["img"]:getData()
	asimgdata:mapPixel(function(x, y, r, g, b, a)
		return 255, 255, 255, a
	end)
	tilesets[file]["img"] = love.graphics.newImage(asimgdata)
	
	tilesets[file]["tiles"] = {}
	
	for tsy = 0, (tilesets[file]["tilesheight"]-1) do
		for tsx = 0, (tilesets[file]["tileswidth"]-1) do
			tilesets[file]["tiles"][(tsy*tilesets[file]["tileswidth"])+tsx] = love.graphics.newQuad(tsx*res, tsy*res, res, res, tilesets[file]["width"], tilesets[file]["height"])
		end
	end
end

function mousein(x1, y1, x2, y2)
	-- Determines whether mouse is in a box with corners x1,y1 and x2,y2
	if (love.mouse.getX() >= x1) and (love.mouse.getX() <= x2) and (love.mouse.getY() >= y1) and (love.mouse.getY() <= y2) then
		return true
	else
		return false
	end
end

function mouseon(x, y, w, h)
	-- Determines whether mouse is on a box with top left corner x1,y1 and width w and height h
	if (love.mouse.getX() >= x) and (love.mouse.getX() < x+w) and (love.mouse.getY() >= y) and (love.mouse.getY() < y+h) then
		return true
	else
		return false
	end
end

function lefttoolscrollbounds()
	if (lefttoolscroll < -368) then
		lefttoolscroll = -368
	elseif (lefttoolscroll > 16) then
		lefttoolscroll = 16
	end
end

function hoverdraw(img, x, y, w, h, s)
	if nodialog and mouseon(x, y, w, h) then
		love.graphics.draw(img, x, y, 0, s)
	else
		love.graphics.setColor(255,255,255,128)
		love.graphics.draw(img, x, y, 0, s)
		love.graphics.setColor(255,255,255,255)
	end
end

function hoverrectangle(r, g, b, a, x, y, w, h, thisbelongstoarightclickmenu)
	if (nodialog or thisbelongstoarightclickmenu) and mouseon(x, y, w, h) then
		love.graphics.setColor(r, g, b, 255)
		love.graphics.rectangle("fill", x, y, w, h)
	else
		love.graphics.setColor(r, g, b, a)
		love.graphics.rectangle("fill", x, y, w, h)
	end
	
	love.graphics.setColor(255,255,255,255)
end

function hoverdiatext(x, y, w, h, text, minumber, active)
	if active or mouseon(x, y, w, h) then
		setColorDIA(255,255,255,255)
		love.graphics.rectangle("fill", x, y-3, w, h)
		
		if love.mouse.isDown("l") then
			currentmultiinput = minumber
		end
	else
		setColorDIA(255,255,255,192)
		love.graphics.rectangle("fill", x, y-3, w, h)
	end
	setColorDIA(0,0,0,255)
	love.graphics.print(text .. (active and __ or ""), x, y-1)
	
	setColorDIA(255,255,255,255)
end

function cycle(var, themax, themin)
	if themin == nil then
		themin = 1
	end

	if var == themax then
		return themin
	else
		return var+1
	end
end

function t(cond, thens, elses)
	if cond then
		return thens
	else
		return elses
	end
end

function spitoutarrays()
	love.system.setClipboardText([[				blocks =
					{
					]] .. fixdig(cb[1], 4, " ") .. [[, ]] .. fixdig(cb[2], 4, " ") .. [[, ]] .. fixdig(cb[3], 4, " ") .. [[, ]] .. fixdig(cb[4], 4, " ") .. [[, ]] .. fixdig(cb[5], 4, " ") .. [[, ]] .. fixdig(cb[6], 4, " ") .. [[,
					]] .. fixdig(cb[7], 4, " ") .. [[, ]] .. fixdig(cb[8], 4, " ") .. [[, ]] .. fixdig(cb[9], 4, " ") .. [[, ]] .. fixdig(cb[10], 4, " ") .. [[, ]] .. fixdig(cb[11], 4, " ") .. [[, ]] .. fixdig(cb[12], 4, " ") .. [[,
					]] .. fixdig(cb[13], 4, " ") .. [[, ]] .. fixdig(cb[14], 4, " ") .. [[, ]] .. fixdig(cb[15], 4, " ") .. [[, ]] .. fixdig(cb[16], 4, " ") .. [[, ]] .. fixdig(cb[17], 4, " ") .. [[, ]] .. fixdig(cb[18], 4, " ") .. [[,
					]] .. fixdig(cb[19], 4, " ") .. [[, ]] .. fixdig(cb[20], 4, " ") .. [[, ]] .. fixdig(cb[21], 4, " ") .. [[, ]] .. fixdig(cb[22], 4, " ") .. [[, ]] .. fixdig(cb[23], 4, " ") .. [[, ]] .. fixdig(cb[24], 4, " ") .. [[,
					]] .. fixdig(cb[25], 4, " ") .. [[, ]] .. fixdig(cb[26], 4, " ") .. [[, ]] .. fixdig(cb[27], 4, " ") .. [[, ]] .. fixdig(cb[28], 4, " ") .. [[, ]] .. fixdig(cb[29], 4, " ") .. [[, ]] .. fixdig(cb[30], 4, " ") .. [[,
					},
				background =
					{
					]] .. fixdig(ca[1], 4, " ") .. [[, ]] .. fixdig(ca[2], 4, " ") .. [[, ]] .. fixdig(ca[3], 4, " ") .. [[, ]] .. fixdig(ca[4], 4, " ") .. [[, ]] .. fixdig(ca[5], 4, " ") .. [[, ]] .. fixdig(ca[6], 4, " ") .. [[,
					]] .. fixdig(ca[7], 4, " ") .. [[, ]] .. fixdig(ca[8], 4, " ") .. [[, ]] .. fixdig(ca[9], 4, " ") .. [[, ]] .. fixdig(ca[10], 4, " ") .. [[, ]] .. fixdig(ca[11], 4, " ") .. [[, ]] .. fixdig(ca[12], 4, " ") .. [[,
					]] .. fixdig(ca[13], 4, " ") .. [[, ]] .. fixdig(ca[14], 4, " ") .. [[, ]] .. fixdig(ca[15], 4, " ") .. [[, ]] .. fixdig(ca[16], 4, " ") .. [[, ]] .. fixdig(ca[17], 4, " ") .. [[, ]] .. fixdig(ca[18], 4, " ") .. [[,
					]] .. fixdig(ca[19], 4, " ") .. [[, ]] .. fixdig(ca[20], 4, " ") .. [[, ]] .. fixdig(ca[21], 4, " ") .. [[, ]] .. fixdig(ca[22], 4, " ") .. [[, ]] .. fixdig(ca[23], 4, " ") .. [[, ]] .. fixdig(ca[24], 4, " ") .. [[,
					]] .. fixdig(ca[25], 4, " ") .. [[, ]] .. fixdig(ca[26], 4, " ") .. [[, ]] .. fixdig(ca[27], 4, " ") .. [[, ]] .. fixdig(ca[28], 4, " ") .. [[, ]] .. fixdig(ca[29], 4, " ") .. [[, ]] .. fixdig(ca[30], 4, " ") .. [[,
					},
				spikes =
					{
					]] .. fixdig(cs[1], 4, " ") .. [[, ]] .. fixdig(cs[2], 4, " ") .. [[, ]] .. fixdig(cs[3], 4, " ") .. [[, ]] .. fixdig(cs[4], 4, " ") .. [[, ]] .. fixdig(cs[5], 4, " ") .. [[, ]] .. fixdig(cs[6], 4, " ") .. [[,
					]] .. fixdig(cs[7], 4, " ") .. [[, ]] .. fixdig(cs[8], 4, " ") .. [[, ]] .. fixdig(cs[9], 4, " ") .. [[, ]] .. fixdig(cs[10], 4, " ") .. [[, ]] .. fixdig(cs[11], 4, " ") .. [[, ]] .. fixdig(cs[12], 4, " ") .. [[,
					]] .. fixdig(cs[13], 4, " ") .. [[, ]] .. fixdig(cs[14], 4, " ") .. [[, ]] .. fixdig(cs[15], 4, " ") .. [[, ]] .. fixdig(cs[16], 4, " ") .. [[, ]] .. fixdig(cs[17], 4, " ") .. [[, ]] .. fixdig(cs[18], 4, " ") .. [[,
					]] .. fixdig(cs[19], 4, " ") .. [[, ]] .. fixdig(cs[20], 4, " ") .. [[, ]] .. fixdig(cs[21], 4, " ") .. [[, ]] .. fixdig(cs[22], 4, " ") .. [[, ]] .. fixdig(cs[23], 4, " ") .. [[, ]] .. fixdig(cs[24], 4, " ") .. [[,
					]] .. fixdig(cs[25], 4, " ") .. [[, ]] .. fixdig(cs[26], 4, " ") .. [[, ]] .. fixdig(cs[27], 4, " ") .. [[, ]] .. fixdig(cs[28], 4, " ") .. [[, ]] .. fixdig(cs[29], 4, " ") .. [[, ]] .. fixdig(cs[30], 4, " ") .. [[,
					}]])
end

function fixdig(number, dig, filler)
	if filler == nil then filler = "0" end

	if string.len(tostring(number)) > dig then
		return string.rep("9", dig)
	elseif string.len(tostring(number)) == dig then
		return tostring(number)
	else
		return string.rep(filler, dig-string.len(tostring(number))) .. tostring(number)
	end
end

function fixdige(number, dig, filler, highfiller)
	if filler == nil then filler = "0" end

	if string.len(tostring(number)) > dig then
		return string.rep(highfiller, dig)
	elseif string.len(tostring(number)) == dig then
		return tostring(number)
	else
		return string.rep(filler, dig-string.len(tostring(number))) .. tostring(number)
	end
end

function syntaxhl(text, x, y, thisistext, addcursor, docolor)
	if thisistext then
		_= docolor and setColorArr(syntaxcolors.textbox)
		love.graphics.print(text, x, y)
		offsetchars = string.len(text) + 1
		
		if addcursor then
			setColorArr(syntaxcolors.cursor)
			love.graphics.print(__, x+((offsetchars-1)*8), y)
		end
		
		return nil
	else
		offsetchars = 0
		
		--if text ~= "" then
		-- Replace characters by one with which we will split.
		text2 = string.gsub(string.gsub(string.gsub(text, "%(", ","), "%)", ","), " ", ",")
		
		partss = explode(",", text2)

		for k,v in pairs(partss) do
			if offsetchars == 0 then -- First word on the line, so it's a command.
				-- But is it recognized?
				if (addcursor and #partss == 1) or knowncommands[v] or knowninternalcommands[v] then
					_= docolor and setColorArr(syntaxcolors.command)
				else
					_= docolor and setColorArr(syntaxcolors.errortext)
				end
			elseif tostring(tonumber(v)) == tostring(v) then -- It's a number!
				_= docolor and setColorArr(syntaxcolors.number)
			elseif string.sub(v, 1, 1) == "$" then
				_= docolor and setColorArr(syntaxcolors.flagname)
			else
				_= docolor and setColorArr(syntaxcolors.generic)
			end
			love.graphics.print(v, x+(offsetchars*8), y)

			_= docolor and setColorArr(syntaxcolors.separator)
			love.graphics.print(string.sub(text, 1+offsetchars+string.len(v), 1+offsetchars+string.len(v)), x+(offsetchars*8)+(string.len(v)*8), y)
			
			offsetchars = offsetchars + (string.len(v)+1)
		end
		
		if addcursor then
			setColorArr(syntaxcolors.cursor)
			love.graphics.print(__, x+((offsetchars-1)*8), y)
		end
		
		if partss[1] == "say" or partss[1] == "reply" then
			if partss[2] == nil then
				return 1
			else
				return tonumber(partss[2])
			end
		elseif partss[1] == "text" then
			if partss[5] == nil then
				return 1
			else
				return tonumber(partss[5])
			end
		end
	end
	--end
end

function setColorArr(yourarray)
	love.graphics.setColor(yourarray[1], yourarray[2], yourarray[3])
end

function justtext(text, thisistext)
	if not thisistext then
		if text:sub(1, 3) == "say" or text:sub(1, 5) == "reply" or text:sub(1, 4) == "text" then
			text2 = string.gsub(string.gsub(string.gsub(text, "%(", ","), "%)", ","), " ", ",")
			
			partss = explode(",", text2)
			
			if partss[1] == "say" or partss[1] == "reply" then
				if partss[2] == nil then
					return 1
				else
					return tonumber(partss[2])
				end
			elseif partss[1] == "text" then
				if partss[5] == nil then
					return 1
				else
					return tonumber(partss[5])
				end
			end
		end
		
		return nil -- also redundant
	end
	
	return nil -- redundant
end

function scriptcontext(text)
	text2 = string.gsub(string.gsub(string.gsub(anythingbutnil(text), "%(", ","), "%)", ","), " ", ",")
	
	parts = explode(",", text2)
	
	if parts[1] == "flag" and parts[2] ~= nil then
		return "flag", tonumber(parts[2]), nil
	elseif (parts[1] == "iftrinkets" or parts[1] == "customiftrinkets") and parts[3] ~= nil and parts[3] ~= "" then
		return "script", parts[3], nil
	elseif (parts[1] == "ifflag" or parts[1] == "customifflag") and parts[2] ~= nil then
		return "flagscript", parts[2], parts[3]
	elseif parts[1] == "gotoposition" and parts[2] ~= nil and parts[3] ~= nil then
		return "position", tonumber(parts[2]), tonumber(parts[3])
	elseif (parts[1] == "gotoroom" or parts[1] == "hidecoordinates" or parts[1] == "showcoordinates") and parts[2] ~= nil and parts[3] ~= nil then
		return "room", tonumber(parts[2]), tonumber(parts[3])
	else
		return nil, nil, nil
	end
end

function processflaglabels()
	-- !! This will also change around lines that belong to text boxes, need to fix!

	-- scriptlines assumed non-empty table of lines
	for k,v in pairs(scriptlines) do
		-- I could split it into parts and then check everything with that, but this is far easier and better performing.
		if v:sub(1,5) == "flag(" or v:sub(1,7) == "ifflag(" or v:sub(1,13) == "customifflag(" then
			-- Ok, how about now?
			text2 = string.gsub(string.gsub(v, "%(", ","), "%)", ",")
			
			partss = explode(",", text2)
			
			if vedmetadata.flaglabel[tonumber(partss[2])] ~= nil then
				-- This flag has a name
				scriptlines[k] = partss[1] .. "($" .. vedmetadata.flaglabel[tonumber(partss[2])] .. "," .. anythingbutnil(partss[3]) .. ")" -- Determining whether an extra space is necessary is unnecessary
			end
		end
	end
end

function langkeys(strin, thesekeys)
	-- Fills in $1 $2 etc in the strings.
	for lk,lv in pairs(thesekeys) do
		strin = strin:gsub("$" .. lk, lv)
	end
	
	return strin
end

function userdatathing(thing)
	for thingy in thing:lines() do
		return thingy
	end
end

function st(name)
	return love.graphics.newImage("tools/sub/" .. name .. ".png")
end

function updatecountdelete(thet)
	-- So what are we removing?
	if thet == 9 then
		count.trinkets = count.trinkets - 1
	elseif thet == 15 then
		count.crewmates = count.crewmates - 1
	end
end

function searchtext(this)
	--[[ Searches scripts (and script names), room names and roomtext
		Returns (array)searchscripts, (array)searchrooms and (array)searchroomtext
		
		Arrays look as follows:
		
		searchscripts =
			{
			[1] =
				{
				name = "scriptname",
				foundline = 1, -- 0 for script name match
				foundlinecontent = "The content of the found line"
				}
			}
			
		searchrooms =
			{
			[1] =
				{
				x = 1,
				y = 1,
				name = "Room name if present"
				-- Maybe in a later stage add a preview of the room for a thumbnail?
				}
			}
			
		searchroomtext =
			{
			[1] =
				{
				x = 1, -- Just the room
				y = 1, -- in which it was found
				data = "The actual roomtext"
				}
			}
	]]
	
	searchscripts = {}; searchrooms = {}; searchroomtext = {}
	
	if this ~= "" then
		this = this:lower():gsub("%%", "%%%%"):gsub("%(", "%%%("):gsub("%)", "%%%)"):gsub("%.", "%%%."):gsub("%+", "%%%+"):gsub("%-", "%%%-"):gsub("%*", "%%%*"):gsub("%?", "%%%?"):gsub("%[", "%%%["):gsub("%^", "%%%^"):gsub("%$", "%%%$")
		
		-- Scripts
		for rvnum = #scriptnames, 1, -1 do
			-- Do this in order of last edited script first.
			-- Or maybe the opposite because an oldest script might be what's harder to recall/find?
			-- Ah well, be specific for now.
			if scriptnames[rvnum]:lower():find(this) ~= nil then
				table.insert(searchscripts, {name=scriptnames[rvnum], foundline=0, foundlinecontent=""})
			end
			
			for k,v in pairs(scripts[scriptnames[rvnum]]) do
				if v:lower():find(this) ~= nil then
					table.insert(searchscripts, {name=scriptnames[rvnum], foundline=k, foundlinecontent=v})
				end
			end
		end
		
		-- Room names
		for k,v in pairs(levelmetadata) do
			if v.roomname:lower():find(this) ~= nil then
				table.insert(searchrooms, {x=k-(math.floor((k-1)/20)*20), y=math.floor((k-1)/20)+1, name=v.roomname})
			end
		end
		
		-- Roomtext
		
	end
	
	return searchscripts, searchrooms, searchroomtext
end

function highlightresult(text, result, x, y)
	offsetchars = 1
	
	result = result:lower():gsub("%%", "%%%%"):gsub("%(", "%%%("):gsub("%)", "%%%)"):gsub("%.", "%%%."):gsub("%+", "%%%+"):gsub("%-", "%%%-"):gsub("%*", "%%%*"):gsub("%?", "%%%?"):gsub("%[", "%%%["):gsub("%^", "%%%^"):gsub("%$", "%%%$")
	
	-- Well then, this changed into some awkward code
	if text:lower():find(result, 1) == nil then
		love.graphics.print(text, x+(offsetchars-1)*8, y)
	else
		repeat
			pos, endpos = text:lower():find(result, offsetchars)
			love.graphics.print(text:sub(offsetchars, pos-1), x+(offsetchars-1)*8, y)
			love.graphics.setColor(255,255,0,255)
			love.graphics.print(text:sub(pos, endpos), x+(pos-1)*8, y)
			love.graphics.setColor(255,255,255,255)
			offsetchars = endpos + 1
		until text:lower():find(result, offsetchars) == nil
		
		love.graphics.print(text:sub(endpos+1, -1), x+endpos*8, y)
	end
end

function flipscrollmore(wheel)
	-- Ok so on OSX by default scrolling is the opposite of Windows, which can feel natural because you're using two fingers instead of rolling a wheel
	-- Now this does not feel normal when you're switching between items instead of scrolling
	-- So on Mac we reverse that with the subtools but you can also reverse this way of scrolling, in which case our flipped code changes to the unnatural feeling one
	-- In which case you can change a setting in Ved to again reverse that
	if s.flipsubtoolscroll then
		if wheel == "wu" then
			return "wd"
		else
			return "wu"
		end
	else
		return wheel
	end
end

function autocorrectroom()
	if levelmetadata[(roomy)*20 + (roomx+1)].directmode == 0 then
		for thist = 1, 1200 do
			local correctret = correcttile(roomx, roomy, thist, selectedtileset, selectedcolor)
			if roomdata[roomy][roomx][thist] ~= correctret then
				roomdata[roomy][roomx][thist] = correctret
			end
		end
	end
end

function thingk()
	keyva = require("keyfunc")(function()
		if state == 1 and (selectedtool == 1 or selectedtool == 2) and mouseon(16+64, 16+48*8+leftsubtoolscroll, 32, 32) then
			subtoolimgs[1][9] = st("1_9");subtoolimgs[2][9] = st("1_9")
		end
	end)
end

-- Lua why do you have to be weird and always pass tables by reference instead of by value.
-- http://stackoverflow.com/a/18975924/3495280
function table.copy(t)
	local t2 = {}
	for kap,vep in pairs(t) do
		if type(vep) == "table" then
			t2[kap] = table.copy(vep)
		else
			t2[kap] = vep
		end
	end
	return t2
end